from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.TypesTool import ContentFactoryMetadata

from Products.CMFTrackback import trackback_globals

from Products.CMFTrackback.config import product_name, plone_product_name, skin_name
from Products.CMFTrackback.Ping import factory_type_information as fti


tools = (
		"CMF Trackback Tool", 
    	)


def setupTools(self, out):
    """
    setup tool
    """
    addTool = self.manage_addProduct[product_name].manage_addTool
    for tool in tools:
        found = 0
        for obj in self.objectValues():
            if obj.meta_type == tool:
                found = 1
                
        if not found:
            addTool(type=tool)
            out.append("Added '%s' tool.\n" % (tool,))

def setupSkin(self, out, skin_name=skin_name, globals=trackback_globals):
    """
    setup skin
    """
    skinstool=getToolByName(self, 'portal_skins')
    if skin_name not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', globals)

    for skinName in skinstool.getSkinSelections():
        path = skinstool.getSkinPath(skinName)
        path = [i.strip() for i in  path.split(',')]
        try:
            if skin_name not in path:
                path.insert(path.index('custom') +1, skin_name)
                out.append('Added "%s" to "%s" skins' % (layer_name, skin))
        except ValueError:
            if skin_name not in path:
                path.append(skin_name)

        path = ','.join(path)
        skinstool.addSkinSelection(skinName, path)

def setupTypes(self, out , fti_list):
    """
    setup types
    """
    typesTool = getToolByName(self, 'portal_types')
    
    # Former types deletion (added by PJG)
    for f in fti_list:
        if f['id'] in typesTool.objectIds():
            out.append('*** Object "%s" already existed in the types tool => deleting\n' % (f['id']))
            self.typesTool._delObject(f['id'])
    
    # Type re-creation
    for f in fti_list:
        # Regular FTI processing
        cfm = apply(ContentFactoryMetadata, (), f)
        typesTool._setObject(f['id'], cfm)
        out.append('Type "%s" registered with the types tool\n' % (f['id']))

def install(self):
    """ Install this product """
    out = []
    setupTools(self, out)
    setupSkin(self, out)
    setupTypes(self, out, fti_list=fti )

    return "\n".join(out)
